C#/IV - VI Ciclo/01 - TiendaVirtualBD/Models/ErrorViewModel.cs
namespace TiendaVirtualBD.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Controllers/CategoriasController.cs
using Microsoft.AspNetCore.Mvc;
using TiendaVirtualBD.Models;

namespace TiendaVirtualBD.Controllers
{
    public class CategoriasController : Controller
    {
        /*  public IActionResult Index()
          {
              return View();
          }*/
        /*  public String Index()
          {
              String mensaje = "Responde el metodo 'Index()' del Controlador 'Categorias'";
              return mensaje;
          }*/
        /* public String MostrarCategoria(int Id)
        {
            String mensaje = "Id solicitado: " + Id.ToString();
            return mensaje;
        } */
        /* public String MostrarCategoria(int Id)
         {
             String mensaje = "Categoria solicitada:\n\n";

             using (TiendaVirtualBdContext BD = new TiendaVirtualBdContext())
             {
                 var listaCategorias = (from c in BD.Categoria
                 where c.Id == Id
                                        select new Categorium
                                        {
                                            Id = c.Id, 
                                            Nombre = c.Nombre,
                                            Activo = c.Activo

                                        }).ToList();

                 if (listaCategorias.Count > 0)
                 {
                     Categorium categoria = listaCategorias.First();
                     String activo = categoria.Activo.GetValueOrDefault() ? "Si" : "No";

                     mensaje += "Id    : " + categoria.Id.ToString() + "\n";
                     mensaje += "Nombre: " + categoria.Nombre + "\n";
                     mensaje += "Activo: " + activo;
                 }
                 else
                 {
                     mensaje = "El Producto no existe en la BD.";
                 }
             }

             return mensaje;
         }
        */
        public IActionResult MostrarCategoria(int Id)
        {
            Categorium categoria = new Categorium();

            using (TiendaVirtualBdContext BD = new TiendaVirtualBdContext())
            {
                var listaCategorias = (from c in BD.Categoria
                                       where c.Id == Id
                                       select new Categorium
                                       {
                                           Id = c.Id,
                                           Nombre = c.Nombre,
                                           Activo = c.Activo

                                       }).ToList();

                if (listaCategorias.Count > 0)
                {
                    categoria = listaCategorias.First();
                    ViewData["activo"] = categoria.Activo.GetValueOrDefault() ? "Si" : "No";
                }
            }

            return View(categoria);
        }

    }
}

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using TiendaVirtualBD.Models;

namespace TiendaVirtualBD.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Controllers/ProductosController.cs
using Microsoft.AspNetCore.Mvc;
using TiendaVirtualBD.Models;

namespace TiendaVirtualBD.Controllers
{
    public class ProductosController : Controller
    {
        //GET
        //dominio:puerto/Productos
        //dominio:puerto/Productos/Index
        public IActionResult Index()
        {
            List<Producto> listaProductos = new List<Producto>();

            using (TiendaVirtualBdContext BD = new TiendaVirtualBdContext())
            {
                listaProductos = (from p in BD.Productos select p).ToList();
            }

            return View(listaProductos);
        }

    }
}

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Views/Categorias/MostrarCategoria.cshtml
@model TiendaVirtualBD.Models.Categorium

@{
    ViewData["Title"] = "Mostrar Categoria";
}
<div>
    <h4>CATEGORIA</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">Id</dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Id)
        </dd>
    </dl>
    <dl class="row">
        <dt class="col-sm-2">Nombre</dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Nombre)
        </dd>
    </dl>
    <dl class="row">
        <dt class="col-sm-2">Id</dt>
        <dd class="col-sm-10">
            @ViewData["activo"]
        </dd>
    </dl>
</div>

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Views/Productos/Index.cshtml
@model IEnumerable<TiendaVirtualBD.Models.Producto>

@{
    ViewData["Title"] = "PRODUCTOS";
}

<h1>Lista de Productos</h1>

<table class="table">
    <thead>
        <tr>
            <th>Id</th>
            <th>Nombre</th>
            <th>Precio</th>
            <th>Destacado</th>
            <th>Activo</th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>@item.Id</td>
                <td>@item.Nombre</td>
                <td>@item.Precio</td>
                <td>@item.Destacado</td>
                <td>@Html.DisplayFor(modelItem => item.Activo)</td>
            </tr>
        }
    </tbody>
</table>

C#/IV - VI Ciclo/01 - TiendaVirtualBD/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TiendaVirtualBD</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/TiendaVirtualBD.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">TiendaVirtualBD</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Productos" asp-action="Index">Mis Productos</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - TiendaVirtualBD - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>